//+------------------------------------------------------------------+
//|                                                CDynamicArray.mqh |
//|                                                          Integer |
//|                          https://login.mql5.com/ru/users/Integer |
//+------------------------------------------------------------------+
#property copyright "Integer"
#property link "https://login.mql5.com/ru/users/Integer"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CDynamicArray
  {
private:
   int               m_ChunkSize;    //  
   int               m_ReservedSize; //   
   int               m_Size;         //    
public:
   double            Element[];      //  .    public, 
                                     //        
   //+------------------------------------------------------------------+
   //|                                                       |
   //+------------------------------------------------------------------+
   void CDynamicArray(int ChunkSize=1024)
     {
      m_Size=0;                            //   
      m_ChunkSize=ChunkSize;               //  
      m_ReservedSize=ChunkSize;            //   
      ArrayResize(Element,m_ReservedSize); //  
     }
   //+------------------------------------------------------------------+
   //|                                    |
   //+------------------------------------------------------------------+
   void AddValue(double Value)
     {
      m_Size++; //    
      if(m_Size>m_ReservedSize)
        { //      
         m_ReservedSize+=m_ChunkSize; //    
         ArrayResize(Element,m_ReservedSize); //    
        }
      Element[m_Size-1]=Value; //  
     }
   //+------------------------------------------------------------------+
   //|                 |
   //+------------------------------------------------------------------+
   int Size()
     {
      return(m_Size);
     }
  };
//+------------------------------------------------------------------+
